=== debian/changelog ===
ros-foxy-rcl (1.1.14-1focal) focal; urgency=high

  * Fix buffer overflow in argument parsing caused by lexer returning length beyond length of string (#979 <https://github.com/ros2/rcl/issues/979>) (#981 <https://github.com/ros2/rcl/issues/981>)
  * Contributors: Shane Loretz

 -- William Woodall <william@osrfoundation.org>  Mon, 25 Jul 2022 07:00:00 -0000

ros-foxy-rcl (1.1.13-1focal) focal; urgency=high



 -- William Woodall <william@osrfoundation.org>  Fri, 04 Feb 2022 08:00:00 -0000

ros-foxy-rcl (1.1.12-1focal) focal; urgency=high

  * Add setter and getter for domain_id in rcl_init_options_t (#678 <https://github.com/ros2/rcl/issues/678>) (#946 <https://github.com/ros2/rcl/issues/946>)
  * Fix test_info_by_topic flaky (#859 <https://github.com/ros2/rcl/issues/859>) (#944 <https://github.com/ros2/rcl/issues/944>)
  * Contributors: Jacob Perron, Tomoya.Fujita

 -- William Woodall <william@osrfoundation.org>  Mon, 31 Jan 2022 08:00:00 -0000

ros-foxy-rcl (1.1.11-1focal) focal; urgency=high

  * Update quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#910 <https://github.com/ros2/rcl/issues/910>)
  * Contributors: Simon Honigmann

 -- William Woodall <william@osrfoundation.org>  Wed, 14 Apr 2021 07:00:00 -0000

ros-foxy-rcl (1.1.10-1focal) focal; urgency=high

  * Update QD to QL 1 (#867 <https://github.com/ros2/rcl/issues/867>)
  * Update QD (#843 <https://github.com/ros2/rcl/issues/843>)
  * Complete rcl package's logging API test coverage (#747 <https://github.com/ros2/rcl/issues/747>)
  * Contributors: Alejandro Hernández Cordero, Christophe Bedard, Jorge Perez, Michel Hidalgo, Stephen Brawner

 -- William Woodall <william@osrfoundation.org>  Wed, 09 Dec 2020 08:00:00 -0000

ros-foxy-rcl (1.1.9-1focal) focal; urgency=high

  * increase timeouts in test_services fixtures for Connext (#745 <https://github.com/ros2/rcl/issues/745>)
  * Add a semicolon to RCUTILS_LOGGING_AUTOINIT. (#816 <https://github.com/ros2/rcl/issues/816>)
  * Zero initialize events an size_of_events members of rcl_wait_set_t (#841 <https://github.com/ros2/rcl/issues/841>)
  * Return OK when finalizing zero-initialized contexts (#842 <https://github.com/ros2/rcl/issues/842>)
  * Make sure to check the return value of rcl APIs. (#838 <https://github.com/ros2/rcl/issues/838>)
  * Fix memory leak because of mock test (#800 <https://github.com/ros2/rcl/issues/800>)
  * Fix that not to deallocate event impl in some failure case (#790 <https://github.com/ros2/rcl/issues/790>)
  * calling fini functions to avoid memory leak (#791 <https://github.com/ros2/rcl/issues/791>)
  * Bump rcl arguments' API test coverage. (#777 <https://github.com/ros2/rcl/issues/777>)
  * Fix rcl arguments' API memory leaks and bugs. (#778 <https://github.com/ros2/rcl/issues/778>)
  * Add coverage tests wait module (#769 <https://github.com/ros2/rcl/issues/769>)
  * Fix wait allocation cleanup (#770 <https://github.com/ros2/rcl/issues/770>)
  * Bump test coverage. (#764 <https://github.com/ros2/rcl/issues/764>)
  * Check rcutils_strdup() outcome immediately. (#768 <https://github.com/ros2/rcl/issues/768>)
  * Cleanup rcl_get_secure_root() implementation. (#762 <https://github.com/ros2/rcl/issues/762>)
  * Add fault injection macros to rcl functions (#727 <https://github.com/ros2/rcl/issues/727>)
  * Yield rcl_context_fini() error codes. (#763 <https://github.com/ros2/rcl/issues/763>)
  * Do not invalidate context before successful shutdown. (#761 <https://github.com/ros2/rcl/issues/761>)
  * Zero initialize guard condition on failed init. (#760 <https://github.com/ros2/rcl/issues/760>)
  * Adding tests to arguments.c (#752 <https://github.com/ros2/rcl/issues/752>)
  * Extend rcl_expand_topic_name() API test coverage. (#758 <https://github.com/ros2/rcl/issues/758>)
  * Add coverage tests 94% service.c (#756 <https://github.com/ros2/rcl/issues/756>)
  * Clean up rcl_expand_topic_name() implementation. (#757 <https://github.com/ros2/rcl/issues/757>)
  * Added path_to_fail to mocking_utils in rcl
  * Complete rcl enclave validation API coverage. (#751 <https://github.com/ros2/rcl/issues/751>)
  * Fix allocation arguments copy (#748 <https://github.com/ros2/rcl/issues/748>)
  * Fix rcl package's logging API error specs and handling. (#746 <https://github.com/ros2/rcl/issues/746>)
  * Fix bug error handling get_param_files (#743 <https://github.com/ros2/rcl/issues/743>)
  * Complete subscription API test coverage (#734 <https://github.com/ros2/rcl/issues/734>)
  * Add deallocate calls to free strdup allocated memory (#737 <https://github.com/ros2/rcl/issues/737>)
  * Add missing calls to rcl_convert_rmw_ret_to_rcl_ret (#738 <https://github.com/ros2/rcl/issues/738>)
  * Add mock tests, publisher 95% coverage (#732 <https://github.com/ros2/rcl/issues/732>)
  * Reformat rmw_impl_id_check to call a testable function (#725 <https://github.com/ros2/rcl/issues/725>)
  * Make sure to call rcl_arguments_fini at the end of the test.
  * Add remap needed null check (#711 <https://github.com/ros2/rcl/issues/711>)
  * Make public ini/fini rosout publisher (#704 <https://github.com/ros2/rcl/issues/704>)
  * Move rcl_remap_copy to public header (#709 <https://github.com/ros2/rcl/issues/709>)
  * Add coverage tests for rcl (#703 <https://github.com/ros2/rcl/issues/703>)
  * Add bad arguments tests for coverage (#698 <https://github.com/ros2/rcl/issues/698>)
  * Improve error checking and handling in subscription APIs. (#739 <https://github.com/ros2/rcl/issues/739>)
  * Fix memory leak in rcl_subscription_init()/rcl_publisher_init() (#794 <https://github.com/ros2/rcl/issues/794>, #834 <https://github.com/ros2/rcl/issues/834>) (#832 <https://github.com/ros2/rcl/issues/832>)
  * Improve rcl init test coverage. (#684 <https://github.com/ros2/rcl/issues/684>)
  * Remove unused check context.c (#691 <https://github.com/ros2/rcl/issues/691>)

